#!/bin/sh
#
# Script to update F-Prot for Linux virus definitions.
# Place it in a subdirectory of the F-Prot installation directory and
# run it from crontab (preferrably daily). Check regularly that the download
# URLs are still valid.
#
# This script is hereby placed on the public domain.
#

cd `dirname $0`
rm -rf fp-def.zip macrdef2.zip *.DEF *.ASC
wget -t 0 -o wget.out -c http://www.complex.is/cgi-bin/get_randomly?fp-def http://www.complex.is/cgi-bin/get_randomly?macrdef2 2>&1 || exit 1
unzip fp-def.zip >/dev/null 2>&1
unzip macrdef2.zip >/dev/null 2>&1
if [ -f MACRO.DEF ]
then
	diff MACRO.DEF ..
	if [ $? -eq 0 ]
	then
		echo `date +"%Y/%m/%d %H:%M:%S "` "No changes in MACRO.DEF - not updated." >>updatedefs.log
	else
		mv MACRO.DEF ..
		echo `date +"%Y/%m/%d %H:%M:%S "` "MACRO.DEF updated." >>updatedefs.log
	fi
fi
if [ -f SIGN.DEF ]
then
	diff SIGN.DEF ..
	if [ $? -eq 0 ]
	then
		echo `date +"%Y/%m/%d %H:%M:%S "` "No changes in SIGN.DEF - not updated." >>updatedefs.log
	else
		mv SIGN.DEF ..
		echo `date +"%Y/%m/%d %H:%M:%S "` "SIGN.DEF updated." >>updatedefs.log
	fi
fi
if [ -f SIGN2.DEF ]
then
	diff SIGN2.DEF ..
	if [ $? -eq 0 ]
	then
		echo `date +"%Y/%m/%d %H:%M:%S "` "No changes in SIGN2.DEF - not updated." >>updatedefs.log
	else
		mv SIGN2.DEF ..
		echo `date +"%Y/%m/%d %H:%M:%S "` "SIGN2.DEF updated." >>updatedefs.log
	fi
fi
