#!/bin/sh
#
# Script to update GeCAD RAV for Linux virus definitions.
# Place it in a subdirectory of the rave/ directory and run it from crontab
# (preferrably daily). Check regularly that the download URLs are still valid.
#
# This script is hereby placed on the public domain.
#

cd `dirname $0`
rm -rf rave.zip *.vd?
wget -t 0 -o wget.log ftp://ftp.gecadsoftware.com/pub/GeCAD/rav8/update/rave.zip
if [ $? -ne 0 ]
then
	echo `date +"%Y/%m/%d %H:%M:%S "` "Error downloading: see wget.log" >>updatedefs.log
else
	unzip rave.zip >/dev/null 2>&1
	if [ ! -f rav8def.vdm ]
	then
		echo `date +"%Y/%m/%d %H:%M:%S "` "Couldn't extract rav8def.vdm" >>updatedefs.log
		exit 0
	fi
	diff rav8def.vdm .. >/dev/null 2>&1
	if [ $? -ne 0 ]
	then
		mv *.vd? .. >/dev/null 2>&1
		echo `date +"%Y/%m/%d %H:%M:%S "` "rav8def.vdm changed -- data files updated." >>updatedefs.log
		exit 0
	fi
	LASTVDM=`ls --sort=n 2???????.vdm | tail -1 2>/dev/null`
	if [ "$LASTVDM" == "" ]
	then
		echo `date +"%Y/%m/%d %H:%M:%S "` "Data files already up-to-date.." >>updatedefs.log
		exit 0
	fi
	diff $LASTVDM .. >/dev/null 2>&1
	if [ $? -ne 0 ]
	then
		mv *.vd? .. >/dev/null 2>&1
		echo `date +"%Y/%m/%d %H:%M:%S "` "Incremental updates changed -- data files updated." >>updatedefs.log
		exit 0
	fi
	echo `date +"%Y/%m/%d %H:%M:%S "` "Data files already up-to-date.." >>updatedefs.log
fi
